// CifiricaDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Cifirica.h"
#include "CifiricaDlg.h"

#include <stdio.h>
#include <io.h>
#include <fcntl.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
extern char sRULEZ[];
extern int	nReplace;
extern bool	bRULEZ;
extern long LocalTime;

bool bAlmostRus	= true;
bool bRYCC			= false;


char *	Cifirica_Translate		(const char *sLAT);
char *	Cifirica_TranslateHTML	(const char *sLAT);
void		Cifirica_Start				(char * fileName);
void		Cifirica_End				();

#define FILE_NAME			"cifirica.dat"
#define FILE_NAME_REV	"cifirica-lr.dat"
#define FILE_NAME_RYCC	"cifirica-rr.dat"

#define MYWM_NOTIFYICON		(WM_APP+100)

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About


class CAboutDlg : public CDialog
{
public:
	CAboutDlg();
	CFont		m_Font;

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	CHyperLink	m_ST1;
	CHyperLink	m_ST2;
	CHyperLink	m_ST3;
	CHyperLink	m_ST4;
	CHyperLink	m_ST6;
	CHyperLink	m_ST7;
	CHyperLink	m_ST8;
	CHyperLink	m_ST9;
	CHyperLink  m_OnLine;
	CHyperLink	m_PoohChat;
	CHyperLink	m_URL1;
	CHyperLink	m_URL2;
	CHyperLink	m_URL3;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	DDX_Control(pDX, IDC_STATIC1, m_ST1);
	DDX_Control(pDX, IDC_STATIC2, m_ST2);
	DDX_Control(pDX, IDC_STATIC3, m_ST3);
	DDX_Control(pDX, IDC_STATIC4, m_ST4);
	DDX_Control(pDX, IDC_ST6, m_ST6);
	DDX_Control(pDX, IDC_ST7, m_ST7);
	DDX_Control(pDX, IDC_ST8, m_ST8);
	DDX_Control(pDX, IDC_ST9, m_ST9);
	DDX_Control(pDX, IDC_ONLINE, m_OnLine);
	DDX_Control(pDX, IDC_POOHCHAT, m_PoohChat);
	DDX_Control(pDX, IDC_EMAIL, m_URL1);
	DDX_Control(pDX, IDC_PHOTO, m_URL2);
	DDX_Control(pDX, IDC_INTERNET, m_URL3);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCifiricaDlg dialog

CCifiricaDlg::CCifiricaDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCifiricaDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCifiricaDlg)
	m_LatText = _T("");
	m_RusText = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	Cifirica_Start		(FILE_NAME);

	m_X = AfxGetApp()->GetProfileInt ("", "X",	0);
	m_Y = AfxGetApp()->GetProfileInt ("", "Y",	0);
	m_H = AfxGetApp()->GetProfileInt ("", "H",	0);
	m_V = AfxGetApp()->GetProfileInt ("", "V",	0);
	m_S = AfxGetApp()->GetProfileString ("", "S",	"");
}

CCifiricaDlg::~CCifiricaDlg()
{
	Cifirica_End	  ();
	AfxGetApp()->WriteProfileInt ("", "X",	m_X);
	AfxGetApp()->WriteProfileInt ("", "Y",	m_Y);
	AfxGetApp()->WriteProfileInt ("", "H",	m_H);
	AfxGetApp()->WriteProfileInt ("", "V",	m_V);
	AfxGetApp()->WriteProfileString ("", "S",	m_S);
}

void CCifiricaDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCifiricaDlg)
	DDX_Control(pDX, IDOK, m_OK);
	DDX_Control(pDX, IDC_CHECK_RULEZ, m_Rulez);
	DDX_Control(pDX, IDC_ABOUT, m_About);
	DDX_Control(pDX, IDC_RUS, m_RusEdit);
	DDX_Control(pDX, IDC_LAT, m_LatEdit);
	DDX_Text(pDX, IDC_LAT, m_LatText);
	DDX_Text(pDX, IDC_RUS, m_RusText);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CCifiricaDlg, CDialog)
	//{{AFX_MSG_MAP(CCifiricaDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_EN_CHANGE(IDC_LAT, OnChangeLat)
	ON_BN_CLICKED(IDC_ABOUT, OnHelp)
	ON_BN_CLICKED(IDC_CHECK_RULEZ, OnCheckRulez)
	ON_WM_SIZE()
	ON_WM_SHOWWINDOW()
	ON_WM_CLOSE()
	ON_WM_GETMINMAXINFO()
	ON_WM_DESTROY()
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCifiricaDlg message handlers

BOOL CCifiricaDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	//----------------------------------------------------------------------------[] 
	//  Start Boris Berdichevski
	{
		LOGFONT lf;
		memset((LPSTR)&lf, 0, sizeof(lf));
		lf.lfHeight = -14;        //    
		lf.lfWidth = 0;
		lf.lfWeight = FW_NORMAL;
		lf.lfCharSet = RUSSIAN_CHARSET;
		strcpy(lf.lfFaceName, "Arial");
		m_Font.CreateFontIndirect(&lf);
		m_RusEdit.SetFont(&m_Font);
		m_LatEdit.SetFont(&m_Font);

		m_Rulez.SetFont(&m_Font);
		m_About.SetFont(&m_Font);
		m_OK.SetFont(&m_Font);
	}
	//  End Boris Berdichevski
	//----------------------------------------------------------------------------[] 

	m_LatEdit.SetWindowText (m_S);

	bRULEZ = false;
	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	OnChangeLat		();
	TrayMessage		(NIM_ADD);
	SetTimer			(0, 100, NULL);
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CCifiricaDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

bool bEnableGetMinMaxInfo=false;
void CCifiricaDlg::OnPaint() 
{
	static bool bFirst=true;
	if (bFirst)
	{
		if (m_H==0)
		{
			m_X = 100;
			m_Y = 100;
			m_H = 500;
			m_V = 500;
			SetWindowPos (NULL, m_X,m_Y,m_H,m_V,SWP_NOZORDER);
			OnHelp ();
		}
		else 
		{
			WINDOWPLACEMENT pl;
			memset (&pl, 0, sizeof (pl));
			pl.length						= sizeof (pl);
			pl.flags							= WPF_RESTORETOMAXIMIZED;
			pl.showCmd						= SW_RESTORE | SW_SHOW;
			pl.rcNormalPosition.left	= m_X;
			pl.rcNormalPosition.top		= m_Y;
			pl.rcNormalPosition.right	= m_H+m_X;
			pl.rcNormalPosition.bottom = m_V+m_Y;

			SetWindowPlacement (&pl);
		}
		bFirst = false;
	}
	bEnableGetMinMaxInfo = true;

	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}
// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CCifiricaDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

bool bNeedTranslate=true;
int  nTickToTranslate=1000;

//______________________________________________________________________________
//                                                                            []
//` Translate																						[]
//                                                                            []
void CCifiricaDlg::Translate ()
{
	CWaitCursor wc;
	bNeedTranslate = false;
	nTickToTranslate=0;
	char SSS[10240];
	m_LatEdit.GetWindowText (m_S);
	
	int nLatText = m_S.GetLength();
	int MAX_LEN  = 40960;
	if (nLatText>MAX_LEN)
	{
		m_S = m_S.Left(MAX_LEN);
		m_S += "\r\n* * *";
	}
	
	long ttt = GetTickCount();
		
	int nALL = 0;
	int nRUS = 0;
	int nRYC = 0;
	typedef unsigned char uchar;
	extern bool ARR_RUSSIAN[];
	extern bool ARR_BUKVA[];
	extern bool ARR_RYCC[];

	for (int i=0; i<m_S.GetLength(); i++) 
	{
		nRUS += ARR_RUSSIAN	[(uchar)m_S[i]];
		nALL += ARR_BUKVA		[(uchar)m_S[i]];
		nRYC += ARR_RYCC		[(uchar)m_S[i]];
	}	
	bAlmostRus	= nRUS <= (nALL/2);
	bRYCC			= (nRYC >= (nALL/2)) && nRYC>8;
	
	Cifirica_End   ();
	if (bRYCC)
		Cifirica_Start (FILE_NAME_RYCC);
	else if (bAlmostRus)
		Cifirica_Start (FILE_NAME);
	else
		Cifirica_Start (FILE_NAME_REV);


	CString RusText = bRYCC? Cifirica_Translate (m_S): Cifirica_TranslateHTML (m_S);

	SSS[0]=0;
	m_RusEdit.SetWindowText  (RusText);
}
//____________________________________________________________________________[]


//______________________________________________________________________________
//                                                                            []
//` OnChangeLat																					[]
//                                                                            []
void CCifiricaDlg::OnChangeLat() 
{
	bNeedTranslate		= true;
	nTickToTranslate	= 0;
}
//____________________________________________________________________________[]



//______________________________________________________________________________
//                                                                            []
//` OnInitDialog																					[]
//                                                                            []
BOOL CAboutDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	//----------------------------------------------------------------------------[] 
	//  Start Boris Berdichevski
	{
		LOGFONT lf;
		memset((LPSTR)&lf, 0, sizeof(lf));
		lf.lfHeight = -14;        //    
		lf.lfWidth = 0;
		lf.lfWeight = FW_NORMAL;
		lf.lfCharSet = RUSSIAN_CHARSET;
		strcpy(lf.lfFaceName, "Arial");
		m_Font.CreateFontIndirect(&lf);
		SetFont(&m_Font);

		m_URL1.SetFont(&m_Font);
		m_URL2.SetFont(&m_Font);
		m_URL3.SetFont(&m_Font);
		m_PoohChat.SetFont(&m_Font);
		m_OnLine.SetFont(&m_Font);
		m_ST1.SetFont(&m_Font);
		m_ST2.SetFont(&m_Font);
		m_ST3.SetFont(&m_Font);
		m_ST4.SetFont(&m_Font);
		m_ST6.SetFont(&m_Font);
		m_ST7.SetFont(&m_Font);
		m_ST8.SetFont(&m_Font);
		m_ST9.SetFont(&m_Font);
	}
	//  End Boris Berdichevski
	//----------------------------------------------------------------------------[] 


   m_URL1.SetURL			(_T("mailto:cifirica@roman.msk.ru"));
	m_URL2.SetURL        (_T("http://www.8008.com/roman/"));
	m_URL3.SetURL        (_T("http://www.8008.com/roman/cifirica/"));
	m_PoohChat.SetURL		(_T("http://www.kiev.com/pooh/"));
	m_OnLine.SetURL		(_T("http://www.kiev.com/pooh/win/lib/cifirica/online/cifirica.cgi"));

	m_URL1.SetColours    (RGB (0,0,128), RGB (0,0,128), RGB (0,0,255));
	m_URL2.SetColours    (RGB (0,0,128), RGB (0,0,128), RGB (0,0,255));
	m_URL3.SetColours    (RGB (0,0,255), RGB (255,0,0), RGB (255,0,0));
	m_PoohChat.SetColours(RGB (0,0,255), RGB (255,0,0), RGB (255,0,0));
	m_OnLine.SetColours	(RGB (128,0,0), RGB (255,0,0), RGB (255,0,0));

	m_URL1.SetUnderline		(false);
	m_URL2.SetUnderline		(false);
	m_URL3.SetUnderline		(true);
	m_PoohChat.SetUnderline	(true);
	m_OnLine.SetUnderline	(false);
	
	m_URL1.SetVisited			(false);
	m_URL2.SetVisited			(false);
	m_URL3.SetVisited			(false);
	m_PoohChat.SetVisited	(false);
	
	m_URL1.SetAutoSize		(false);
	m_URL2.SetAutoSize		(false);
	m_URL3.SetAutoSize		(false);
	m_PoohChat.SetAutoSize	(false);

	m_ST1.SetColours    (RGB (0,0,0), RGB (0,0,0), RGB (0,0,0));
	m_ST2.SetColours    (RGB (0,0,0), RGB (0,0,0), RGB (0,0,0));
	m_ST3.SetColours    (RGB (0,0,0), RGB (0,0,0), RGB (0,0,0));
	m_ST4.SetColours    (RGB (0,0,0), RGB (0,0,0), RGB (0,0,0));
	m_ST6.SetColours    (RGB (0,0,0), RGB (0,0,0), RGB (0,0,0));
	m_ST7.SetColours    (RGB (0,0,0), RGB (0,0,0), RGB (0,0,0));
	m_ST8.SetColours    (RGB (0,0,0), RGB (0,0,0), RGB (0,0,0));
	m_ST9.SetColours    (RGB (0,0,0), RGB (0,0,0), RGB (0,0,0));
   m_ST1.SetURL			(_T("http://www.8008.com/roman/"));
   m_ST2.SetURL			(_T("http://www.8008.com/roman/"));
   m_ST3.SetURL			(_T("http://www.8008.com/roman/"));
   m_ST4.SetURL			(_T("http://www.8008.com/roman/"));
   m_ST6.SetURL			(_T("http://www.8008.com/roman/"));
   m_ST7.SetURL			(_T("http://www.8008.com/roman/"));
   m_ST8.SetURL			(_T("http://www.8008.com/roman/"));
   m_ST9.SetURL			(_T("http://www.8008.com/roman/"));
	

	bNeedTranslate		= true;
	nTickToTranslate	= 1000;

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CCifiricaDlg::OnHelp()
{
	CAboutDlg dlgAbout;
	dlgAbout.DoModal();	
}

void CCifiricaDlg::OnCheckRulez()
{
	char SSS [1024];
	char DIR [1024];
	GetCurrentDirectory (512, DIR);
 

	sprintf (SSS, "c:\\program files\\aditor\\aditor.exe %s\\%s", DIR, bRYCC? FILE_NAME_RYCC: (bAlmostRus?FILE_NAME:FILE_NAME_REV));
	UINT res = WinExec (SSS, SW_SHOW);
	if (res == ERROR_FILE_NOT_FOUND || res==ERROR_PATH_NOT_FOUND)
	{
		sprintf (SSS, "notepad.exe %s\\%s", DIR, FILE_NAME);
		WinExec (SSS, SW_SHOW);
	}
}

void CCifiricaDlg::OnSize(UINT nType, int cx, int cy) 
{
	if (nType == SIZE_MINIMIZED)
	{        
		OnSetTray ();
		return;
	}
	CDialog::OnSize(nType, cx, cy);

	if (cx*2>cy*3)
	{
		if (m_LatEdit.m_hWnd)
			m_LatEdit.SetWindowPos (NULL, 5, 4, cx/2-8, cy-8, SWP_NOZORDER);
		if (m_RusEdit.m_hWnd)
			m_RusEdit.SetWindowPos (NULL, cx/2+4, 4, cx/2-8, cy-42, SWP_NOZORDER);
	}
	else
	{
		if (m_LatEdit.m_hWnd)
			m_LatEdit.SetWindowPos (NULL, 5, 4, cx-8, cy/2-15, SWP_NOZORDER);
		if (m_RusEdit.m_hWnd)
			m_RusEdit.SetWindowPos (NULL, 6, cy/2-5, cx-10, cy/2-36, SWP_NOZORDER);
	}


	int L = cx/2+4;
	int rcx = cx;
	if (cx<300 && cx*2<cy*3) 
	{
		cx=cx*2;
		L = 6;
	}
	if (m_Rulez.m_hWnd)
	{
		m_Rulez.SetWindowPos	(NULL, L, cy-34, cx/5, 30, SWP_NOZORDER);
		m_Rulez.SetWindowText (cx/5>60?cx/5>120?" ":"":".");
		L += cx/5;
	}
	if (m_About.m_hWnd)
	{
		m_About.SetWindowPos	(NULL, L+8, cy-34, cx/10, 30, SWP_NOZORDER);
		m_About.SetWindowText (cx/5>70?cx/5>120?" *** *** *** ":" * * * ":" * ");
		L += 8+cx/10;
	}
	if (m_OK.m_hWnd)
	{
		L += 8;
		m_OK.SetWindowPos	(NULL, L, cy-34, rcx-L-4, 30, SWP_NOZORDER);
		m_OK.SetWindowText ((cx/5>60)?(cx/5>70)?(cx/5>150)?"   ":"  ":"  ":"");
	}
}

void CCifiricaDlg::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	static bool bFirst=true;
	if (bFirst)
	{
		SetWindowPos	(NULL, -100,-100,0,0,SWP_NOZORDER);
		PostMessage (WM_PAINT, 0,0);
		bFirst = false;
	}
	CDialog::OnShowWindow(bShow, nStatus);
}

void CCifiricaDlg::OnClose() 
{
	TrayMessage  (NIM_DELETE);

	if (m_H!=0)
	{
		WINDOWPLACEMENT pl;
		GetWindowPlacement (&pl);
		m_X = pl.rcNormalPosition.left;
		m_Y = pl.rcNormalPosition.top;
		m_H = pl.rcNormalPosition.right - m_X;
		m_V = pl.rcNormalPosition.bottom - m_Y;
	}

	CDialog::OnClose();
}

BOOL IN_TRAY = FALSE;
void CCifiricaDlg::OnSetTray()
{
	IN_TRAY         = TRUE;
	ShowWindow  (SW_HIDE);
	TrayMessage (NIM_ADD);
}
void CCifiricaDlg::OnTrayRestore ()
{
	IN_TRAY          = FALSE;
	ShowWindow (SW_RESTORE);
	SetForegroundWindow  ();
}

void CCifiricaDlg::TrayMessage (DWORD NIM)
{
	static BOOL   INIT        = FALSE;
	static HICON  hICON_DELAY = AfxGetApp()->LoadIcon (IDR_MAINFRAME);
	
	if (!INIT) NIM = NIM_ADD;
	INIT           = TRUE   ;
	
	NOTIFYICONDATA tnd;
	
	tnd.cbSize      = sizeof(NOTIFYICONDATA);
	tnd.hWnd        = m_hWnd;
	tnd.uID         = IDR_MAINFRAME;
	
	tnd.uFlags          = NIF_MESSAGE|NIF_ICON|NIF_TIP;
	tnd.uCallbackMessage= MYWM_NOTIFYICON;
	tnd.hIcon           = hICON_DELAY;
	strcpy                (tnd.szTip, " 2.1");
	
	Shell_NotifyIcon (NIM, &tnd);
}

LRESULT CCifiricaDlg::WindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
{
	if (message==MYWM_NOTIFYICON)
	{
		switch (lParam)
		{
		case WM_RBUTTONDOWN:
		case WM_LBUTTONDOWN:
		case WM_LBUTTONDBLCLK:
			if (IN_TRAY) OnTrayRestore ();
			else 
			{
				ShowWindow (SW_SHOW | SW_RESTORE);
				SetForegroundWindow   ();
			}
			break;
		}
	}

	return CDialog::WindowProc(message, wParam, lParam);
}

void CCifiricaDlg::OnOK() 
{
	TrayMessage (NIM_DELETE);
	OnClose ();
	CDialog::OnOK();
}

void CCifiricaDlg::OnGetMinMaxInfo (MINMAXINFO FAR* lpMMI)
{
	CDialog::OnGetMinMaxInfo (lpMMI);
	if (bEnableGetMinMaxInfo)
	{
		lpMMI->ptMinTrackSize.x =  200;
		lpMMI->ptMinTrackSize.y =  200;
	}
}

void CCifiricaDlg::OnDestroy() 
{
	OnClose ();
	CDialog::OnDestroy();
	TrayMessage (NIM_DELETE);	
}

void CCifiricaDlg::OnTimer(UINT nIDEvent) 
{
	if (bNeedTranslate)
	{
		nTickToTranslate++;

		if (nTickToTranslate>5)
		{
			Translate ();
		}
	}

	CDialog::OnTimer(nIDEvent);
}
