// ParmParser.cpp: implementation of the CParmParser class.
//
//////////////////////////////////////////////////////////////////////

#include "string.h"
#include "stdio.h"
#include "ParmParser.h"
#include "assert.h"
#include <stdlib.h>

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CParmParser::CParmParser()
{

}

CParmParser::~CParmParser()
{
	delete lpLine;
	delete pPairs;
	delete pValues;
	delete pKeyLens;
	delete pValLens;
}

CParmParser::CParmParser(char * Line)
{
	lpLine=new char[strlen(Line)+1];
	strcpy(lpLine,Line);
	nPairs=0;
	pPairs=new int[100];
	pValues=new int[100];
	pKeyLens=new int[100];
	pValLens=new int[100];
	pPairs[0]=pValues[0]=pKeyLens[0]=pValLens[nPairs]=0;
	int i;
	for(i=0;i<(int)strlen(lpLine);i++) {
		if(lpLine[i]=='=') {
			pKeyLens[nPairs]=i-pPairs[nPairs];
			pValues[nPairs]=i+1;
			pValLens[nPairs]=0;
		}
		if((lpLine[i]=='&')||(lpLine[i]=='?')) {
			if(pValues[nPairs]!=pPairs[nPairs])
				pValLens[nPairs]=i-pValues[nPairs];
			pPairs[++nPairs]=i+1;
			pValues[nPairs]=pPairs[nPairs];
			pKeyLens[nPairs]=0;
		}
	}
	if(!pKeyLens[nPairs])
		pKeyLens[nPairs]=i-pValues[nPairs];
	if(pValues[nPairs]!=pPairs[nPairs])
		pValLens[nPairs]=i-pValues[nPairs];
	nPairs++;
}

int CParmParser::IsKey(char * pKey)
{
	return (GetKeyNum(pKey)!=-1);
}

char * CParmParser::Parse(char *Src, char *Dst)
{
/*	FILE *ttt=fopen("ttt.ttt","at");
	fprintf(ttt,"%s\n",Src);
	fclose(ttt);*/
	char *OutBuf=Dst;
	int OutPos=0;
	for(int i=0;i<(int)strlen(Src);i++) {
		if(Src[i]=='%') {
			unsigned int c;
			char cc[5];
			if(Src[i+1]=='u') {
				char *win="";
				cc[4]=0;
				strncpy(cc,Src+i+2,4);
				sscanf(cc,"%x",&c);
				OutBuf[OutPos++]=win[c-0x410];
				i+=5;
			} else {
				cc[2]=0;
				strncpy(cc,Src+i+1,2);
				sscanf(cc,"%x",&c);
				//if(c=='<') c=' ';
				OutBuf[OutPos++]=(unsigned char)c;
				i+=2;
			}
		} else if((Src[i]=='+')/*||(Src[i]=='<')*/)
			OutBuf[OutPos++]=' ';
		else
			OutBuf[OutPos++]=Src[i];
	}
	OutBuf[OutPos]=0;
	return OutBuf;
}

char * CParmParser::GetKey(int n, char *Dst)
{
	strncpy(Dst,lpLine+pPairs[n],pKeyLens[n]);
	Dst[pKeyLens[n]]=0;
	return Dst;
}

char * CParmParser::GetValue(int n, char * Dst)
{
	strncpy(Dst,lpLine+pValues[n],pValLens[n]);
	Dst[pValLens[n]]=0;
	return Dst;
}

char * CParmParser::GetKeyValue(char * Key, char * Dst)
{
	int nKey=GetKeyNum(Key);
	Dst[0]=0;
	if(nKey==-1)
		return 0;
	char * Val = new char [102400];
	GetValue(nKey,Val);
	Parse(Val,Dst);
	delete Val;
	return Dst;
}

int CParmParser::GetKeyValLen(char * Key)
{
	int nKey=GetKeyNum(Key);
	if(nKey==-1)
		return 0;
	return pValLens[nKey];
}

int CParmParser::GetKeyNum(char * pKey)
{
	char Key[1024],PKey[1024];
	for(int i=0;i<nPairs;i++) {
		GetKey(i,Key);
		Parse(Key,PKey);
		if(strcmp(PKey,pKey)==0)
			return i;
	}
	return -1;
}

void pEncode(char *Parm, char *To)
{
	assert(1);
	int i1,i2=0;
	for(i1=0;i1<(int)strlen(Parm);i1++) {
		if((Parm[i1]=='&')||(Parm[i1]=='+')||(Parm[i1]=='%')||(Parm[i1]=='=')||(Parm[i1]>126)||(Parm[i1]<' ')) {
			char a[4];
			sprintf(a,"%%%02x",(unsigned int)(unsigned char)Parm[i1]);
			To[i2++]=a[0];
			To[i2++]=a[1];
			To[i2++]=a[2];
		} else if(Parm[i1]==' ')
			To[i2++]='+';
		else
			To[i2++]=Parm[i1];
	}
	To[i2]=0;
}

int CParmParser::GetKeyInt(char *Key)
{
	char pKey[30];
	GetKeyValue(Key,pKey);
	return atoi(pKey);
}

void CParmParser::Debug()
{
	printf("<!-- \nQuery was %s\nAdd was %s\n -->",lpLine,Add);
}
